package sv.script;

import java.util.*;

public class COMMANDStatement extends Statement {
  public final static int SET        = 0;
  public final static int ANIMATE    = 1;
  public final static int NEXT       = 2;
  public final static int PREVIOUS   = 3;
  

  public COMMANDStatement(String input, String input2) {
     super(COMMAND, input);
     try { parse(input2); } catch (Exception e) {}
  }

  protected void parse(String str) throws ScriptSyntaxError {
     StringTokenizer st = new StringTokenizer(str);
     int tokens = st.countTokens();

     if (tokens < 2) 
        throw new ScriptSyntaxError("Missing terms.");

     Vector argvec = new Vector();

     while (st.hasMoreTokens()) {
        String astr = st.nextToken();

        if (astr.startsWith("$")) {
           argvec.addElement(new Argument(Argument.VARIABLE, 
                                                  astr.substring(1)));
        } else {
           char c = astr.charAt(0);
           if (Character.isDigit(c)) {
              try {
                 argvec.addElement(new Argument(Argument.CONSTANT_INT,
                                       Integer.valueOf(astr).intValue()));
               } catch (Exception e) {
                  throw new ScriptSyntaxError("Expect integer constant.");
               }

           } else
              argvec.addElement(new Argument(Argument.CONSTANT_STRING, astr));
        }
     }
     args = new Argument[argvec.size()];
     argvec.copyInto(args);
  }

} // end of class




