package sv.script;

import java.util.*;

public class Lexical {

  public final static int NONE      = 0;
  public final static int COMMENT   = 1;
  public final static int BLOCK     = 2;
  public final static int STATEMENT = 3;
  
  private int type = NONE;

  /**
   * lexical analyzer of a line
   */
  public Lexical(String input) {
     parse(input);
  }

  /**
   * return this line's type
   */
  public int getType() {
     return type;
  }

  private void parse(String input) {
     String str = input.trim();

     if (str.length() < 1) 
        type = NONE;

     else if (str.startsWith("//")) 
        type = COMMENT;
      
     else if (str.length() > 5 && 
            str.substring(0, 5).toLowerCase().equals("print"))
        type = STATEMENT;

     else if (str.indexOf(":") > 0) 
        type = BLOCK;

     else 
        type = STATEMENT;
  }

} // end of class
