package sv.script;

import java.io.*;
import java.util.*;

public class SVParser {
  private Vector stmtBlock;     // statement block vector

  public SVParser(BufferedReader in) {
     stmtBlock = new Vector();
     try { parse(in); } catch (Exception e) {}

  }

  public Vector getBlocks() {
     return stmtBlock;
  }

  private void parse(BufferedReader in) throws ScriptSyntaxError {
      String input;
      Lexical lex = null;
      StatementBlock block = null;
      int type;
          
      try {
         while ((input = in.readLine()) != null) {
            lex = new Lexical(input);

            type = lex.getType();

            switch (type) {
               case Lexical.NONE:
               case Lexical.COMMENT:
                  break;

               case Lexical.BLOCK:
                  block = new StatementBlock(input);
                  stmtBlock.addElement(block);
                  break;

               case Lexical.STATEMENT:
  		  if (block == null) 
                     throw new ScriptSyntaxError("Script should be start with block.");
                  else 
                     block.addStatement(ParseStatement.getStatement(input));
                  
                  break;
            }

         }

      } catch (Exception e) {
          e.printStackTrace();
      }
  }

} // end of class
