package sv.script;

public class Argument {
  private int type = -1;  

  public final static int CONSTANT_INT       = 0;
  public final static int CONSTANT_STRING    = 1;
  public final static int VARIABLE           = 2;
  public final static int EQUAL_OPER         = 3;
  public final static int NOT_EQUAL_OPER     = 4;

  private String varName = null;
  private String stringVal = null;
  private int intVal = 0;
  private long longVal = 0;

  public Argument(int t, String input) {
    type = t;

    if (t == VARIABLE) {
       varName = input;
    } else if (t == CONSTANT_STRING) {
       stringVal = input;
    }
  }


  public Argument(int t, int val) {
    type = t;

    if (t == CONSTANT_INT) {
       intVal = val;
    }
  }

  public Argument(int t) {
    type = t;
  }

  /**
   * return argument type
   */
  public int getType() {
     return type;
  }

  public String getVarName() {
     return varName;
  }

  public String getStringVal() {
     return stringVal;
  }

  public int getIntVal() {
    return intVal;
  }

  public long getLongVal() {
    return longVal;
  }

  public void setStringVal(String str) {
     stringVal = str;
  }

  public void setIntVal(int i) {
     intVal = i;
  }
  public void setLongVal(long l) {
     longVal = l;
  }




} // end of class




