package sv.script;

import java.util.*;

public class IFStatement extends Statement {

  public IFStatement(String input, String input2) {
     super(IF, input);
     try { parse(input2); } catch (Exception e) {}
  }

  protected void parse(String str) throws ScriptSyntaxError {
     StringTokenizer st = new StringTokenizer(str);
     if (st.countTokens() < 5)
        throw new ScriptSyntaxError("Usage: if $var oper $var2|const goto block_name");

     String[] astr = new String[5];

     for (int i=0; i<5; i++)
        astr[i] = st.nextToken();
     
     if (!str.startsWith("$"))
        throw new ScriptSyntaxError("First argument of READ should be variable.")
;
     args = new Argument[4];

     args[0] = new Argument(Argument.VARIABLE, astr[0].substring(1));
      
     if (astr[1].equals("!="))
        args[1] = new Argument(Argument.NOT_EQUAL_OPER);
     else if (astr[1].equals("=="))
        args[1] = new Argument(Argument.EQUAL_OPER);
     else
        throw new ScriptSyntaxError("Unknown operator.");

     if (astr[2].startsWith("$")) {
System.out.println("Variable comparison is NOT supported yet."); 
     } else {
        try {
           args[2] = new Argument(Argument.CONSTANT_INT,
                       Integer.valueOf(astr[2]).intValue());
        } catch (Exception e) {
           throw new ScriptSyntaxError("Expect integer constant.");
        }
     }

     if (!astr[3].equalsIgnoreCase("goto"))
        throw new ScriptSyntaxError("Usage: if $var oper $var2|const goto block_name");

     args[3] = new Argument(Argument.CONSTANT_STRING, astr[4]);
  }

} // end of class




