package sv.script;

import java.util.*;

public class READStatement extends Statement {

  public READStatement(String input, String input2) {
     super(READ, input);
     try { parse(input2); } catch (Exception e) {}
  }

  protected void parse(String str) throws ScriptSyntaxError {
     if (!str.startsWith("$"))
        throw new ScriptSyntaxError("First argument of READ should be variable.");
     StringTokenizer st = new StringTokenizer(str);
     if (st.countTokens() < 2) 
        throw new ScriptSyntaxError("Usage: READ $var filename");

     args = new Argument[2];

     args[0] = new Argument(Argument.VARIABLE, st.nextToken().substring(1));
     args[1] = new Argument(Argument.CONSTANT_STRING, st.nextToken());
  }

} // end of class




