package sv.script;

import java.util.*;

public class ParseStatement {

  public static Statement getStatement(String input) throws ScriptSyntaxError {
     Statement stmt = null;
     String str = input.trim();
     if (str == null || str.length() < 1) 
        throw new ScriptSyntaxError("Statement is null");
     
     StringTokenizer st = new StringTokenizer(str);
     if (st.countTokens() < 1) 
        throw new ScriptSyntaxError("Statement is null");
     String keyword = st.nextToken().toLowerCase();
     str = str.substring(keyword.length()).trim();

     if (keyword.equals("read")) {
        stmt = new READStatement(input, str);      

     } else if (keyword.equals("wait")) {
        stmt = new WAITStatement(input, str);  

     } else if (keyword.equals("command")) {
        stmt = new COMMANDStatement(input, str);  

     } else if (keyword.equals("print")) {
        stmt = new PRINTStatement(input, str);  

     } else if (keyword.equals("if")) {
        stmt = new IFStatement(input, str);  

     } else if (keyword.equals("goto")) {
        stmt = new GOTOStatement(input, str);  

     } else if (keyword.equals("exit")) {
        stmt = new EXITStatement(input, str);  

     } else {
       throw new ScriptSyntaxError("Unknown keyword: " + keyword);
     }

     return stmt;
  }

  
} // end of class
