package sv.script;

import java.util.Vector;

public abstract class Statement {
  protected int keyword = -1;  
  protected String orig = null;
  protected Argument[] args = null;

  public final static int READ      = 0;
  public final static int WAIT      = 1; 
  public final static int COMMAND   = 2;
  public final static int PRINT     = 3; 
  public final static int IF        = 4; 
  public final static int GOTO      = 5; 
  public final static int EXIT      = 6; 

  public Statement(int key, String input) {
     keyword = key;
     orig = input;
  }

  /**
   * return original input string
   */
  public String getInputString() {
     return orig;
  }

  /**
   * return keyword value
   */
  public int getKeyword() {
     return keyword;
  }


  /**
   * return arguments
   */
  public Argument[] getArgs() {
     return args;
  }

  /**
   * parse the arguments
   */
  protected abstract void parse(String str) throws ScriptSyntaxError;

} // end of class
