package sv.script;

import java.util.*;

public class StatementBlock {

  private Vector statementVec;
  private String blockName = null;

  public StatementBlock(String input) {
     statementVec = new Vector();
     try {
        parse(input);
     } catch (Exception e) {}
  }

  /**
   * add statement into this statement block
   */
  public void addStatement(Statement stmt) {
     statementVec.addElement(stmt);
  }

  /**
   * return block name
   */
  public String  getBlockName() {
     return blockName;
  }

  /**
   * return statements
   */
  public Vector getStatementVector() {
     return statementVec;
  }

  private void parse(String input) throws ScriptSyntaxError {
     if (input.length() < 1) throw new ScriptSyntaxError("Missing block name.");

     int idx = input.indexOf(":");
     if (idx < 1) throw new ScriptSyntaxError("Missing block name.");

     blockName = input.substring(0, idx);
     if (blockName == null) throw new ScriptSyntaxError("Missing block name.");
     //System.out.println("block name: " +  blockName);
  }

} // end of class

