package sv.ui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.*;
import javax.swing.*;


/** 
 * SlideInputDialog.java
 * To get the user input
 * @version 1.0
 * @author Byeongseob Ki
 */


public class SlideInputDialog extends Dialog implements ActionListener {
    private JSlider slider;
    private Label slideValue;

    // choosed value by slider
    int choosed;

    public SlideInputDialog(Frame frame, 
       String title, String lbl1, String lbl2, int min, int max, int val) {

        super(frame, title, true);   // make it modal
        choosed = val;
        makeGUI(title, lbl1, lbl2, min, max, val);
        pack();
    }

    public void actionPerformed(ActionEvent e) {
        String command = e.getActionCommand();

        if (command.equals("Done"))
            dispose();
    }

    public int getChoosedValue() {
        return choosed;
    }

    public Dimension getPreferredSize() {
        return new Dimension(320, 150);
    }

    private void makeGUI(String title, String lbl1, String lbl2, 
                             int min, int max, int val) {
        setLayout(new BorderLayout());

        JPanel p = new JPanel();
        p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
        p.setBorder(new TitledBorder(title));

        p.add(new Label(lbl1, 0));
        p.add(new Label(lbl2, 0));

	Panel p2 = new Panel();
	p2.setLayout(new BorderLayout());
	p2.add("Center", 
	         slider = new JSlider(JSlider.HORIZONTAL, min, max, val));
        p2.add("East", slideValue = new Label(String.valueOf(choosed)));

	//slider.setPaintTicks(true);
	//slider.setMajorTickSpacing(100);
	//slider.setMinorTickSpacing(50); 
	//slider.setPaintLabels(true);
	//slider.setSnapToTicks(true);
        slider.putClientProperty( "JSlider.isFilled", Boolean.TRUE ); 
	p.add(p2);
        //p.add(Box.createRigidArea(new Dimension(1, 20)));
        createSlideListener();

        JPanel btnp = new JPanel();
        btnp.setLayout(new FlowLayout(FlowLayout.RIGHT));

        Button button = new Button("Done");
        button.addActionListener(this);
        btnp.add(button);

        add("Center", p);
        add("South", btnp);
    }

  // slide value changes
  void createSlideListener() {
     ChangeListener changeListener = new ChangeListener() {
        public void stateChanged(ChangeEvent e) {
          choosed = slider.getValue();
	  slideValue.setText(String.valueOf(choosed));
        }
     };
     slider.addChangeListener(changeListener);
  }
 
}

